﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace GeneratorLib
{
    public class ZadaniVeze
    {
        public string Cesta;
        public int X, Y;
        public string Typ;
        public HashSet<Kostka> Kostky;

        public ZadaniVeze(string cesta)
        {
            Cesta = cesta;
            var lines = Geneartor.ReadBuffer.ContainsKey(cesta)? Geneartor.ReadBuffer[cesta]: File.ReadAllLines(cesta);
            if(!Geneartor.ReadBuffer.ContainsKey(cesta))Geneartor.ReadBuffer[cesta] = lines;
            var zadani = lines.First();
            var splat = zadani.Split(' ').Where(s=>!string.IsNullOrWhiteSpace(s)).ToArray();
            X = int.Parse(splat[0]);
            Y = int.Parse(splat[1]);
            Typ = splat[2];

            Kostky = new HashSet<Kostka>(lines.Skip(1).Select(l => new Kostka(l)));
        }

        public override string ToString()
        {
            return string.Format("{0} {1} {2}", X, Y, Typ);
        } 
    }
}
